//+------------------------------------------------------------------+
//|                                                   InfoProfit.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

#resource "\\Include\\Controls\\res\\CloseDisable.bmp"
#resource "\\Include\\Controls\\res\\Close.bmp"
#resource "\\Include\\Controls\\res\\RestoreDisable.bmp"
#resource "\\Include\\Controls\\res\\ExpandDisable.bmp"
#resource "\\Include\\Controls\\res\\TurnOn.bmp"
#resource "\\Include\\Controls\\res\\TurnOff.bmp"

string CloseDisable="::Include\\Controls\\res\\CloseDisable.bmp";
string CloseOff="::Include\\Controls\\res\\Close.bmp";
string RollOn="::Include\\Controls\\res\\RestoreDisable.bmp";
string RollOff="::Include\\Controls\\res\\ExpandDisable.bmp";
string TurnOn="::Include\\Controls\\res\\TurnOn.bmp";
string TurnOff="::Include\\Controls\\res\\TurnOff.bmp";

#include <Tools\DateTime.mqh>
#define EQUAL 0
#define LESS -1
#define MORE 1
#include <Object.mqh>
#include <Arrays\ArrayObj.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ENUM_SORT_TYPE
  {
   SORT_BY_TEXT,
   SORT_BY_NUMBER
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CLineTable: public CObject
  {
private:
   string            m_text;
   double            m_number;
   double            m_number2;
   double            m_number3;
public:
                     CLineTable();
                     CLineTable(string text,double number,double number2,double number3)
     {
      m_text=text;
      m_number=number;
      m_number2=number2;
      m_number3=number3;
     }
   string Text()const{return m_text;}
   double Number()const{return m_number;}
   double Number2()const{return m_number2;}
   double Number3()const{return m_number3;}
   virtual int Compare(const CObject *node,const int mode=0) const
     {
      const CLineTable *line=node;
      switch(mode)
        {
         case SORT_BY_TEXT:
            if(line.Text()==this.Text())
            return EQUAL;
            else if(line.Text()<this.Text())
               return MORE;
            else
               return LESS;
         case SORT_BY_NUMBER:
            if(line.Number()==this.Number())
            return EQUAL;
            else if(line.Number()<this.Number())
               return MORE;
            else
               return LESS;

            if(line.Number2()==this.Number2())
               return EQUAL;
            else if(line.Number2()<this.Number2())
               return MORE;
            else
               return LESS;

            if(line.Number3()==this.Number3())
               return EQUAL;
            else if(line.Number3()<this.Number3())
               return MORE;
            else
               return LESS;
        }
      return EQUAL;
     }
  };
CArrayObj Table;

double Loss[];
double Profit[];
double Net_profit[];
bool MarketWatch=true;
int total_symbol;
int total_symbol2;
int Width;
int Height;
string form1="form1_";
string form2="form2_";
bool show_close=false;
bool show_roll = false;
bool show_turn = false;
CDateTime dates;
double cum_net_profit;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   total_symbol=SymbolsTotal(MarketWatch);
   ArrayResize(Loss,total_symbol);
   ArrayResize(Profit,total_symbol);
   ArrayResize(Net_profit,total_symbol);

   ArrayInitialize(Loss,0);
   ArrayInitialize(Profit,0);
   ArrayInitialize(Net_profit,0);
   EventSetTimer(1);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectsDeleteAll(0,form1);
   ObjectsDeleteAll(0,form2);
   EventKillTimer();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTimer()
  {
   total_symbol=SymbolsTotal(MarketWatch);
   if(total_symbol2!=total_symbol)
     {
      total_symbol2=SymbolsTotal(MarketWatch);
      ArrayResize(Loss,total_symbol);
      ArrayResize(Profit,total_symbol);
      ArrayResize(Net_profit,total_symbol);

      ArrayInitialize(Loss,0);
      ArrayInitialize(Profit,0);
      ArrayInitialize(Net_profit,0);
     }
   cum_net_profit=0;
   for(int i=0;i<total_symbol;i++)
     {
      string symbol=SymbolName(i,MarketWatch);
      cum_net_profit+=GetProfit(symbol,Loss[i],Profit[i],Net_profit[i]);
     }

   Width=ChartWidthInPixels()-20;
   Height=ChartHeightInPixelsGet();

   if(show_turn)from_create2();
   if(!show_turn)from_create1();
   if(!show_turn && !show_roll)from_create3();
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      if(sparam==form1+(string)1)
        {
         show_close=(int)ObjectGetInteger(0,form1+(string)1,OBJPROP_STATE);
         if(show_close)ExpertRemove();

        }

      if(sparam==form1+(string)3 || sparam==form1+(string)2)
        {
         show_turn=(int)ObjectGetInteger(0,form1+(string)3,OBJPROP_STATE);
         show_roll=(int)ObjectGetInteger(0,form1+(string)2,OBJPROP_STATE);
        }
      if(!show_turn || !show_roll)
        {
         from_create1();
         from_create3();
        }

      if(show_turn)
        {
         ObjectsDeleteAll(0);
         from_create2();
        }

      if(!show_turn)
        {
         ObjectsDeleteAll(0);
         from_create1();
        }

      if(!show_turn && !show_roll)from_create3();
      ChartRedraw(0);
     }

  }
//+------------------------------------------------------------------+
double  GetProfit(string symbol,double &loss,double&profit,double &net_profit)
  {
   loss=0;
   profit=0;
   net_profit=0;

   if(HistorySelect(0,TimeCurrent()))
     {
      int deals=HistoryDealsTotal();
      for(int i=0;i<deals;i++)
        {
         ulong deal_ticket=HistoryDealGetTicket(i);
         if(HistoryDealGetString(deal_ticket,DEAL_SYMBOL)!=symbol)continue;
         if(HistoryDealGetInteger(deal_ticket,DEAL_ENTRY)!=DEAL_ENTRY_OUT)continue;
         double pr=HistoryDealGetDouble(deal_ticket,DEAL_PROFIT);
         if(pr>0)profit+=pr;
         if(pr<0)loss+=pr;
         net_profit+=pr;
        }
     }
     return(net_profit);
  }
//+------------------------------------------------------------------+
void from_create1()
  {

   int i=0;
   int x = Width-20;
   int y = 0;


   RectLabelCreate(0,form1+(string)i,0,0,0,Width,20,clrDodgerBlue,BORDER_RAISED);i++;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,CloseOff,CloseDisable,0,0,0,0,show_close);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,RollOn,RollOff,0,0,0,0,show_roll);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y+2,TurnOff,TurnOn,0,0,0,0,show_turn);i++;x-=18;
   LabelCreate(0,form1+(string)i,0,15,2,TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" : "+dates.DayName(),10,clrBlack);i++;

  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void from_create2()
  {

   int i=0;
   int x = 50;
   int y = 0;
   RectLabelCreate(0,form1+(string)i,0,10,0,60,20,clrDodgerBlue,BORDER_RAISED);i++;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,CloseOff,CloseDisable,0,0,0,0,show_close);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,RollOn,RollOff,0,0,0,0,show_roll);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y+2,TurnOff,TurnOn,0,0,0,0,show_turn);i++;x-=18;
  }
//+------------------------------------------------------------------+
void from_create3()
  {

   int i=0;
   int x = Width-20;
   int y = 0;


   RectLabelCreate(0,form1+(string)i,0,0,0,Width,20,clrDodgerBlue,BORDER_RAISED);i++;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,CloseOff,CloseDisable,0,0,0,0,show_close);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,RollOn,RollOff,0,0,0,0,show_roll);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y+2,TurnOff,TurnOn,0,0,0,0,show_turn);i++;x-=18;
   LabelCreate(0,form1+(string)i,0,15,2,TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" : "+dates.DayName(),10,clrBlack);i++;

   i=10;
   x = 5;
   y = 25;

   RectLabelCreate(0,form2+(string)i,0,0,20,Width,Height,clrWhiteSmoke,BORDER_SUNKEN);i++;

   int limit=total_symbol;
//Table.Sort(SORT_BY_TEXT);
//for(int k = 0; k < limit; k++)
   for(int k=limit-1; k>=0; k--)
     {
      //string n = (string)(i+1);
      //if(StringLen(n) < 2)n = "0"+n;
      //string text = "" + n;
      Table.InsertSort(new CLineTable(SymbolName(k,MarketWatch),Net_profit[k],Loss[k],Profit[k]));
     }
//  :
//for(int i = 0; i < Table.Total(); i++)
//{
//  CLineTable* line = Table.At(i);
//  printf(line.Text() + "\t" + (string)line.Number());
//}
//   : 
   Table.Sort(SORT_BY_NUMBER);
//  :
//printf("");
//for(int k = 0; k < Table.Total(); k++)
   for(int k=Table.Total()-1; k>=0; k--)
     {
      CLineTable *line=Table.At(k);
      //printf(line.Text() + "\t" + (string)line.Number());
      if(line.Number()==0)continue;
      LabelCreate(0,form2+(string)i,0,x,y,line.Text(),10,clrGreen);i++;
      LabelCreate(0,form2+(string)i,0,x+100,y,"Loss:",10,clrBlack);i++;
      LabelCreate(0,form2+(string)i,0,x+135,y,DoubleToString(line.Number2(),2),10,Color(line.Number2()));i++;

      LabelCreate(0,form2+(string)i,0,x+200,y,"Profit:",10,clrBlack);i++;
      LabelCreate(0,form2+(string)i,0,x+235,y,DoubleToString(line.Number3(),2),10,Color(line.Number3()));i++;

      LabelCreate(0,form2+(string)i,0,x+300,y,"NetProfit:",10,clrBlack);i++;
      LabelCreate(0,form2+(string)i,0,x+355,y,DoubleToString(line.Number(),2),10,Color(line.Number()));i++;

      y+=15;
      if(y>=Height-20)
        {
         x+=450;
         y=25;
        }
     }
   y+=15;
   LabelCreate(0,form2+(string)i,0,x+200,y,"Summ Net Profit:",10,clrBlack);i++;
   LabelCreate(0,form2+(string)i,0,x+300,y,DoubleToString(cum_net_profit,2),10,Color(cum_net_profit));i++;
   Table.Clear();

//   for(int n=0;n<total_symbol;n++)
//     {
//      if(Net_profit[n]==0)continue;
//      LabelCreate(0,form2+(string)i,0,x,y,SymbolName(n,MarketWatch),10,clrGreen);i++;
//      LabelCreate(0,form2+(string)i,0,x+100,y,"Loss:",10,clrBlack);i++;
//      LabelCreate(0,form2+(string)i,0,x+135,y,DoubleToString(Loss[n],2),10,Color(Loss[n]));i++;
//
//      LabelCreate(0,form2+(string)i,0,x+200,y,"Profit:",10,clrBlack);i++;
//      LabelCreate(0,form2+(string)i,0,x+235,y,DoubleToString(Profit[n],2),10,Color(Profit[n]));i++;
//
//      LabelCreate(0,form2+(string)i,0,x+300,y,"NetProfit:",10,clrBlack);i++;
//      LabelCreate(0,form2+(string)i,0,x+355,y,DoubleToString(Net_profit[n],2),10,Color(Net_profit[n]));i++;
//
//      y+=15;
//      if(y>=Height-20)
//        {
//         x+=450;
//         y=25;
//        }
//     }

  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int Color(double sig)
  {
   if(sig>0)return(clrBlue);
   if(sig<0)return(clrRed);
   return(clrMediumAquamarine);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID=0,// ID 
                  const string            name="Button",            //  
                  const int               sub_window=0,             //  
                  const int               x=0,                      //    X
                  const int               y=0,                      //    Y
                  const int               width=50,                 //  
                  const int               height=18,                //  
                  const string            text="Button",            // 
                  const int               font_size=10,             //  
                  const bool              state=false,              // /
                  const color             clr=clrBlack,             //  
                  const color             back_clr=C'236,233,216',  //  
                  const color             border_clr=clrNONE,       //  
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //                     
                  const string            font="Arial",             //                  
                  const bool              back=false,               //   
                  const bool              selection=false,          //   
                  const bool              hidden=true,              //    
                  const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---  
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---     
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
bool RectLabelCreate(const long             chart_ID=0,// ID 
                     const string           name="RectLabel",         //  
                     const int              sub_window=0,             //  
                     const int              x=0,                      //    X
                     const int              y=0,                      //    Y
                     const int              width=50,                 // 
                     const int              height=18,                // 
                     const color            back_clr=C'236,233,216',  //  
                     const ENUM_BORDER_TYPE border=BORDER_SUNKEN,     //  
                     const color            clr=clrRed,               //    (Flat)
                     const int              line_width=1,             //   
                     const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    

                     const ENUM_LINE_STYLE  style=STYLE_SOLID,//   

                     const bool             back=false,               //   
                     const bool             selection=false,          //   
                     const bool             hidden=true,              //    
                     const long             z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,border);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---     (  Flat)
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---     
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,line_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
bool BitmapLabelCreate(const long              chart_ID=0,// ID 
                       const string            name="BmpLabel",          //  
                       const int               sub_window=0,             //  
                       const int               x=0,                      //    X
                       const int               y=0,                      //    Y
                       const string            file_on="",               //    On
                       const string            file_off="",              //    Off
                       const int               width=0,                  // X-  
                       const int               height=0,                 // Y-  
                       const int               x_offset=10,              //     X
                       const int               y_offset=10,              //     Y
                       const bool              state=false,              // /
                       const color             clr=clrRed,               //    
                       const int               point_width=1,            //   
                       const ENUM_LINE_STYLE   style=STYLE_SOLID,        //    
                       const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                       const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //                        

                       const bool              back=false,               //   
                       const bool              selection=false,          //   
                       const bool              hidden=true,              //    
                       const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_BITMAP_LABEL,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---     On  Off
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,0,file_on))
     {
      Print(__FUNCTION__,
            ":  Error Code = ",GetLastError());
      return(false);
     }
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,1,file_off))
     {
      Print(__FUNCTION__,
            ": Error Code = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---    ;     
//---      ()  , 
//---   ;        ,
//---     ,    
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//--- ,        
//---       ;  
//---          
   ObjectSetInteger(chart_ID,name,OBJPROP_XOFFSET,x_offset);
   ObjectSetInteger(chart_ID,name,OBJPROP_YOFFSET,y_offset);
//--- ,      (  )
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//---        
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,point_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
bool EditCreate(const long             chart_ID=0,// ID 
                const string           name="Edit",              //  
                const int              sub_window=0,             //  
                const int              x=0,                      //    X
                const int              y=0,                      //    Y
                const int              width=50,                 // 
                const int              height=18,                // 
                const string           text="Text",              // 
                const int              font_size=10,             //                  
                const color            clr=clrBlack,             //  
                const color            back_clr=clrWhite,        //  
                const ENUM_ALIGN_MODE  align=ALIGN_LEFT,//   
                const bool             read_only=true,//  
                const color            border_clr=clrNONE,       //  
                const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    
                const string           font="Arial",             // 
                const bool             back=false,               //   
                const bool             selection=false,          //   
                const bool             hidden=true,              //    
                const long             z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_EDIT,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---      
   ObjectSetInteger(chart_ID,name,OBJPROP_ALIGN,align);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_READONLY,read_only);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
bool LabelCreate(const long              chart_ID=0,// ID 
                 const string            name="Label",             //  
                 const int               sub_window=0,             //  
                 const int               x=0,                      //    X
                 const int               y=0,                      //    Y
                 const string            text="Label",             // 
                 const int               font_size=10,             //  
                 const color             clr=clrRed,               // 
                 const string            font="Arial",             //  
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //     
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //                                                                  
                 const double            angle=0.0,                //                   
                 const bool              back=false,               //   
                 const bool              selection=false,          //   
                 const bool              hidden=true,              //    
                 const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---    
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//---  
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
int ChartWidthInPixels(const long chart_ID=0)
  {
   long result=-1;
   ResetLastError();
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
   return((int)result);
  }
//+------------------------------------------------------------------+
int ChartHeightInPixelsGet(const long chart_ID=0,const int sub_window=0)
  {
   long result=-1;
   ResetLastError();
   if(!ChartGetInteger(chart_ID,CHART_HEIGHT_IN_PIXELS,sub_window,result))
     {
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
   return((int)result);
  }
//+------------------------------------------------------------------+
